OGRE: Ogre::ManualObject::ManualObjectSection Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::ManualObject::ManualObjectSection Class Reference

Built, renderable section of geometry. More...

`#include <OgreManualObject.h>`

Inheritance diagram for Ogre::ManualObject::ManualObjectSection:
[legend]

## Public Member Functions
| ManualObjectSection (ManualObject *parent, const MaterialPtr &mat, RenderOperation::OperationType opType)
| ManualObjectSection (ManualObject *parent, const String &materialName, RenderOperation::OperationType opType, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
virtual | ~ManualObjectSection ()
void | convertToSubMesh (SubMesh *sm) const
| convert this section to a SubMesh
bool | get32BitIndices () const
| Get whether we need 32-bit indices.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
const String & | getMaterialGroup (void) const
| Retrieve the material group in use.
const String & | getMaterialName (void) const
| Retrieve the material name in use.
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
RenderOperation * | getRenderOperation (void)
| Retrieve render operation for manipulation.
Real | getSquaredViewDepth (const Ogre::Camera *) const override
| Returns the squared distance between the camera and this renderable.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
void | set32BitIndices (bool n32)
| Set whether we need 32-bit indices.
void | setMaterial (const MaterialPtr &mat)
| Update the material in use.
void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| update the material name in use
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Detailed Description

Built, renderable section of geometry.

## Constructor & Destructor Documentation

## ◆ ManualObjectSection() [1/2]

Ogre::ManualObject::ManualObjectSection::ManualObjectSection | ( | ManualObject * | parent,
|  | const String & | materialName,
|  | RenderOperation::OperationType | opType,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )

References Ogre::ManualObject::ManualObject(), and Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ ManualObjectSection() [2/2]

Ogre::ManualObject::ManualObjectSection::ManualObjectSection | ( | ManualObject * | parent,
|  | const MaterialPtr & | mat,
|  | RenderOperation::OperationType | opType )

Remarks
  mat should not be null.

References Ogre::ManualObject::ManualObject().

## ◆ ~ManualObjectSection()

virtual Ogre::ManualObject::ManualObjectSection::~ManualObjectSection | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getRenderOperation() [1/2]

RenderOperation * Ogre::ManualObject::ManualObjectSection::getRenderOperation | ( | void |  | ) |

Retrieve render operation for manipulation.

## ◆ getMaterialName()

const String & Ogre::ManualObject::ManualObjectSection::getMaterialName | ( | void |  | ) | const
| inline

Retrieve the material name in use.

References Ogre::BLANKSTRING.

## ◆ getMaterialGroup()

const String & Ogre::ManualObject::ManualObjectSection::getMaterialGroup | ( | void |  | ) | const
| inline

Retrieve the material group in use.

References Ogre::BLANKSTRING.

## ◆ setMaterialName()

void Ogre::ManualObject::ManualObjectSection::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

update the material name in use

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ setMaterial()

void Ogre::ManualObject::ManualObjectSection::setMaterial | ( | const MaterialPtr & | mat | ) |

Update the material in use.

Remarks
  mat should not be null.

## ◆ set32BitIndices()

void Ogre::ManualObject::ManualObjectSection::set32BitIndices | ( | bool | n32 | ) |
| inline

Set whether we need 32-bit indices.

## ◆ get32BitIndices()

bool Ogre::ManualObject::ManualObjectSection::get32BitIndices | ( |  | ) | const
| inline

Get whether we need 32-bit indices.

## ◆ getMaterial()

const MaterialPtr & Ogre::ManualObject::ManualObjectSection::getMaterial | ( | void |  | ) | const
| overridevirtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

## ◆ getRenderOperation() [2/2]

void Ogre::ManualObject::ManualObjectSection::getRenderOperation | ( | RenderOperation & | op | ) |
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getWorldTransforms()

void Ogre::ManualObject::ManualObjectSection::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implements Ogre::Renderable.

## ◆ getSquaredViewDepth()

Real Ogre::ManualObject::ManualObjectSection::getSquaredViewDepth | ( | const Ogre::Camera * |  | ) | const
| overridevirtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

## ◆ getLights()

const LightList & Ogre::ManualObject::ManualObjectSection::getLights | ( | void |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ convertToSubMesh()

void Ogre::ManualObject::ManualObjectSection::convertToSubMesh | ( | SubMesh * | sm | ) | const

convert this section to a SubMesh

The documentation for this class was generated from the following file:

- OgreManualObject.h